<?php

namespace SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctSincronizarVariacaoPreco {
    
    const NOME = "FCT_SINCRONIZAR_VARIACAO_PRECO";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrorg
     * @param string $idorcacontr
     * @param integer $nrseq
     * 
     * @return string
     */
    public function executar($itPrecBaseServ, $tipo, $nrorg, $operador) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRSEQITPRECBSERV", Param::PARAM_INPUT,  $itPrecBaseServ,  Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_TIPO",             Param::PARAM_INPUT,  $tipo,            Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param("P_NRORG",            Param::PARAM_INPUT,  $nrorg,           Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_OPERADOR",         Param::PARAM_INPUT,  $operador,        Param::PARAM_TYPE_STR));
        
        $procedure->execute();
    }
    
}

?>

